#include "prjlibs-c/standards.h"
#include <sys/ioctl.h>

#include "fdtools.h"

#ifdef TIOCCONS

int grabconsole(int fd) {
  int x=1;
  if (ioctl(fd, TIOCCONS, (char*)&x)!=0)
    return grabconsole_ioctl;
  return grabconsole_success;
}

#else

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/strredir.h>
#include <errno.h>
#include <stropts.h>

#include "skalibs/include/stddjb.h"

int grabconsole(int fd) {
  int const console=open("/dev/console", O_RDONLY);
  if (console<0)
    return grabconsole_devconsole_open;
  if (ioctl(console, SRIOCSREDIR, fd)!=0) {
    int const error=errno;
    fd_close(console);
    errno=error;
    return grabconsole_ioctl;
  }
  if (fd_close(console)!=0)
    return grabconsole_devconsole_close;
  return grabconsole_success;
}

#endif
